SystemOrganization addCategory: #ConfigurationOfSMark!

Object subclass: #ConfigurationOfSMark
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSMark'!

!ConfigurationOfSMark class methodsFor: 'development support' stamp: 'StefanMarr 7/5/2013 11:09'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSMark class methodsFor: 'private' stamp: 'StefanMarr 7/5/2013 11:09'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSMark class methodsFor: 'private' stamp: 'StefanMarr 7/5/2013 11:09'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSMark class methodsFor: 'private' stamp: 'StefanMarr 7/5/2013 11:09'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSMark class methodsFor: 'metacello tool support' stamp: 'StefanMarr 7/5/2013 11:09'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSMark class methodsFor: 'loading' stamp: 'StefanMarr 7/5/2013 11:09'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSMark class methodsFor: 'loading' stamp: 'StefanMarr 7/5/2013 11:09'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSMark class methodsFor: 'loading' stamp: 'StefanMarr 7/5/2013 11:09'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSMark class methodsFor: 'accessing' stamp: 'StefanMarr 7/5/2013 11:09'!
project

	^self new project! !

!ConfigurationOfSMark class methodsFor: 'development support' stamp: 'StefanMarr 7/5/2013 11:09'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSMark methodsFor: 'baselines' stamp: 'StefanMarr 7/5/2013 11:18'!
baseline100: spec
	<version: '1.0.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/StefanMarr/SMark/main'.
		
		spec package: 'Scripting'.
		spec package: 'SMark' with: [ spec requires: #(Scripting) ].
	].! !

!ConfigurationOfSMark methodsFor: 'baselines' stamp: 'StefanMarr 7/5/2013 11:19'!
baseline110: spec
	<version: '1.1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/StefanMarr/SMark/main'.
		
		spec package: 'Scripting'.
		spec package: 'SMark' with: [ spec requires: #(Scripting) ].
	].! !

!ConfigurationOfSMark methodsFor: 'accessing' stamp: 'StefanMarr 7/5/2013 11:09'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfSMark methodsFor: 'baselines' stamp: 'StefanMarr 7/5/2013 11:19'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1.0'.
! !

!ConfigurationOfSMark methodsFor: 'accessing' stamp: 'StefanMarr 7/5/2013 11:09'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSMark methodsFor: 'baselines' stamp: 'StefanMarr 7/5/2013 11:19'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0.0'.
! !

!ConfigurationOfSMark methodsFor: 'baselines' stamp: 'StefanMarr 7/5/2013 11:24'!
version100: spec
	<version: '1.0.0' imports: #('1.0.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: ''.
		spec author: 'StefanMarr'.
		spec timestamp: '7/05/2013 11:30'.
		
		spec
			package: 'Scripting'          with: 'Scripting-StefanMarr.23';
			package: 'SMark'              with: 'SMark-StefanMarr.51'].! !
